﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;

namespace Campus {
    public class AbilityMenuIcon {
        private Texture2D m_normalIcon;
        public Texture2D NormalIcon {
            get { return m_normalIcon; }
        }

        private Texture2D m_mouseOverIcon;
        public Texture2D MouseOverIcon {
            get { return m_mouseOverIcon; }
        }

        private Texture2D m_clickedIcon;
        public Texture2D ClickedIcon {
            get { return m_clickedIcon; }
        }

        private Texture2D m_disabledIcon;
        public Texture2D DisabledIcon {
            get { return m_disabledIcon; }
        }
        public AbilityMenuIcon(Texture2D normalIcon, Texture2D mouseOverIcon, Texture2D clickedIcon, Texture2D disabledIcon) {
            m_normalIcon = normalIcon;
            m_mouseOverIcon = mouseOverIcon;
            m_clickedIcon = clickedIcon;
            m_disabledIcon = disabledIcon;
        }

        public Dictionary<MenuButtonState, Texture2D> CreateMenuButtonTextures() {
            Dictionary<MenuButtonState, Texture2D> buttonTextures = new Dictionary<MenuButtonState, Texture2D>();
            buttonTextures.Add(MenuButtonState.idle, m_normalIcon);
            buttonTextures.Add(MenuButtonState.rollover, m_mouseOverIcon);
            buttonTextures.Add(MenuButtonState.active, m_clickedIcon);
            buttonTextures.Add(MenuButtonState.invalid, m_disabledIcon);

            return buttonTextures;
        }
    }
}
