﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework;

namespace Campus {
    class GatewayToHell : Structure {
        static public Texture2D BuildingTexture { get; private set; }
        static public Texture2D StaticTeamColorTexture { get; private set; }
        static public Texture2D ConstructionTexture { get; private set; }
        static public Vector2 StaticOrigin { get; private set; }
        static public List<Vector2> StaticTilesOccupied { get; private set; }
        static public void InitializeTextures(ContentManager Content) {
            BuildingTexture = Content.Load<Texture2D>("Structures/building_hell_base");
            StaticTeamColorTexture = Content.Load<Texture2D>("Structures/building_hell_team");
            ConstructionTexture = Content.Load<Texture2D>("Structures/building_hell_build");
            StaticOrigin = new Vector2(60, 177);

            StaticTilesOccupied = new List<Vector2>();
            StaticTilesOccupied.Add(new Vector2(0, 0));  // Tile this building is placed on.
            StaticTilesOccupied.Add(new Vector2(0, 1));
            StaticTilesOccupied.Add(new Vector2(0, 2));
            StaticTilesOccupied.Add(new Vector2(0, 3));
            StaticTilesOccupied.Add(new Vector2(1, 0));
            StaticTilesOccupied.Add(new Vector2(1, 1));
            StaticTilesOccupied.Add(new Vector2(1, 2));
            StaticTilesOccupied.Add(new Vector2(1, 3));
            StaticTilesOccupied.Add(new Vector2(2, 0));
            StaticTilesOccupied.Add(new Vector2(2, 1));
            StaticTilesOccupied.Add(new Vector2(2, 2));
            StaticTilesOccupied.Add(new Vector2(2, 3));
            StaticTilesOccupied.Add(new Vector2(3, 0));
            StaticTilesOccupied.Add(new Vector2(3, 1));
            StaticTilesOccupied.Add(new Vector2(3, 2));
            StaticTilesOccupied.Add(new Vector2(3, 3));
        }
        private void CreateAbilities() {
            Abilities.Add("Build Lawyer", new BuildUnitAbility(MenuIcons.BuildRobotIcon, this, BuildRequirements.Units.Robot));
        }

        public GatewayToHell(Player owner, Level level)
            : base(BuildingTexture, StaticTeamColorTexture, ConstructionTexture, StaticTilesOccupied, StaticOrigin, Vector2.Zero, 1000, owner, level, new Dictionary<string,Ability>(), new Dictionary<string,AbilitySubMenu>())
        {
            m_name = "Gateway to Hell";

            CreateAbilities();

            //TODO: Create abilities
        }

        public override string ToString()
        {
            string returnString = m_name + "\n" +
                                  "HP: " + m_currentHP + "/" + m_maxHP + "\nThis creates lawyers.";
            return returnString;
        }
        public override void Update(Player player)
        {
        }
    }
}
