﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System.Text;

namespace Campus
{
    class MenuGraphic
    {
        #region Properties

        /// <summary>
        /// The texture (graphic) for the MenuGraphic object.
        /// </summary>
        public Texture2D Texture { get; private set; }

        /// <summary>
        /// The position given within the MouseMenu's coordinate system.
        /// </summary>
        public Vector2 Position { get; private set; }

        #endregion

        #region Constructors

        /// <summary>
        /// MenuGraphic is a simple class that contains only a graphic and a position.
        /// This is used with the MouseMenu class and is drawn last in the MouseMenu and thus
        /// will appear on top of everything else.  The position of MenuGraphic should be
        /// given with the knowledge that (0, 0) will be located at the upper left of the
        /// MouseMenu NOT in the upper left of the screen.
        /// </summary>
        /// <param name="texture">The graphic to be drawn.</param>
        /// <param name="position">The position, within the MouseMenu's coordinate system.</param>
        public MenuGraphic(Texture2D texture, Vector2 position)
        {
            this.Texture = texture;
            this.Position = position;
        }

        #endregion
    }
}
