﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;

namespace Campus {
    class MothersBasement : Structure {
        static public Texture2D BuildingTexture { get; private set; }
        static public Texture2D StaticTeamColorTexture { get; private set; }
        static public Texture2D ConstructionTexture { get; private set; }
        static public Vector2 StaticOrigin { get; private set; }
        static public List<Vector2> StaticTilesOccupied { get; private set; }
        static public void InitializeTextures(ContentManager Content) {
            BuildingTexture = Content.Load<Texture2D>("Structures/building_mothers_base");
            StaticTeamColorTexture = Content.Load<Texture2D>("Structures/building_mothers_team");
            ConstructionTexture = Content.Load<Texture2D>("Structures/building_mothers_build");
            StaticOrigin = new Vector2(45, 119);
            // Set up the tiles that get turned into walls when this building is placed.
            StaticTilesOccupied = new List<Vector2>();
            StaticTilesOccupied.Add(new Vector2(0, 0));  // Tile this building is placed on.
            StaticTilesOccupied.Add(new Vector2(0, 1));
            StaticTilesOccupied.Add(new Vector2(0, 2));
            StaticTilesOccupied.Add(new Vector2(1, 0));
            StaticTilesOccupied.Add(new Vector2(1, 1));
            StaticTilesOccupied.Add(new Vector2(1, 2));
            StaticTilesOccupied.Add(new Vector2(2, 0));
            StaticTilesOccupied.Add(new Vector2(2, 1));
            StaticTilesOccupied.Add(new Vector2(2, 2));
        }

        private void CreateAbilities() {
            Abilities.Add("Build Computer Scientist", new BuildUnitAbility(MenuIcons.BuildComputerScientistIcon, this, BuildRequirements.Units.ComputerScientist));
        }
        public MothersBasement(Player player, Level level)
            : base(BuildingTexture, StaticTeamColorTexture, ConstructionTexture, StaticTilesOccupied, StaticOrigin, Vector2.Zero, 500, player, level, new Dictionary<String, Ability>(), new Dictionary<string,AbilitySubMenu>())
        {
            m_name = "Mother's Basement";
            CreateAbilities();

            // TODO: Create Nexus Abilities / Submenus

        }
        protected override void Destroy()
        {
            base.Destroy();
        }
        public override string ToString()
        {
            string returnString = m_name + "\n" +
                                  "HP: " + m_currentHP + "/" + m_maxHP + "\n" + 
                                  "The Mother's Basement produces the ultimate unit, the Computer Scientist.";
            return returnString;
        }
        public override void Update(Player player)
        {
        }
    }
}
